import '../node_modules/prop-types/index.js';
import { exports as propTypesExports } from '../_virtual/index.js';

var colorPropType = propTypesExports.oneOfType([
    propTypesExports.oneOf([
        'primary',
        'secondary',
        'success',
        'danger',
        'warning',
        'info',
        'dark',
        'light',
    ]),
    propTypesExports.string,
]);
var placementPropType = propTypesExports.oneOf([
    'auto',
    'auto-start',
    'auto-end',
    'top-end',
    'top',
    'top-start',
    'bottom-end',
    'bottom',
    'bottom-start',
    'right-start',
    'right',
    'right-end',
    'left-start',
    'left',
    'left-end',
]);
var shapePropType = propTypesExports.oneOfType([
    propTypesExports.oneOf([
        'rounded',
        'rounded-top',
        'rounded-end',
        'rounded-bottom',
        'rounded-start',
        'rounded-circle',
        'rounded-pill',
        'rounded-0',
        'rounded-1',
        'rounded-2',
        'rounded-3',
    ]),
    propTypesExports.string,
]);
var textColorsPropType = propTypesExports.oneOfType([
    colorPropType,
    propTypesExports.oneOf(['white', 'muted']),
    propTypesExports.string,
]);
var triggerPropType = propTypesExports.oneOf(['hover', 'focus', 'click']);

export { colorPropType, placementPropType, shapePropType, textColorsPropType, triggerPropType };
//# sourceMappingURL=Types.js.map
