import { __rest, __assign } from '../../node_modules/tslib/tslib.es6.js';
import React__default, { forwardRef, useContext } from 'react';
import '../../node_modules/prop-types/index.js';
import classNames from '../../node_modules/classnames/index.js';
import { CAccordionItemContext } from './CAccordionItem.js';
import { exports as propTypesExports } from '../../_virtual/index.js';

var CAccordionButton = forwardRef(function (_a, ref) {
    var children = _a.children, className = _a.className, rest = __rest(_a, ["children", "className"]);
    var _b = useContext(CAccordionItemContext), visible = _b.visible, setVisible = _b.setVisible;
    var _className = classNames('accordion-button', { collapsed: !visible }, className);
    return (React__default.createElement("button", __assign({ type: "button", className: _className, "aria-expanded": !visible, onClick: function () { return setVisible(!visible); } }, rest, { ref: ref }), children));
});
CAccordionButton.propTypes = {
    children: propTypesExports.node,
    className: propTypesExports.string,
};
CAccordionButton.displayName = 'CAccordionButton';

export { CAccordionButton };
//# sourceMappingURL=CAccordionButton.js.map
