import { __rest, __assign } from '../../node_modules/tslib/tslib.es6.js';
import React__default, { forwardRef } from 'react';
import '../../node_modules/prop-types/index.js';
import classNames from '../../node_modules/classnames/index.js';
import { CLink } from '../link/CLink.js';
import { exports as propTypesExports } from '../../_virtual/index.js';

var CBreadcrumbItem = forwardRef(function (_a, ref) {
    var children = _a.children, active = _a.active, className = _a.className, href = _a.href, rest = __rest(_a, ["children", "active", "className", "href"]);
    var _className = classNames('breadcrumb-item', {
        active: active,
    }, className);
    return (React__default.createElement("li", __assign({ className: _className }, (active && { 'aria-current': 'page' }), rest, { ref: ref }), href ? React__default.createElement(CLink, { href: href }, children) : children));
});
CBreadcrumbItem.propTypes = {
    active: propTypesExports.bool,
    children: propTypesExports.node,
    className: propTypesExports.string,
    href: propTypesExports.string,
};
CBreadcrumbItem.displayName = 'CBreadcrumbItem';

export { CBreadcrumbItem };
//# sourceMappingURL=CBreadcrumbItem.js.map
