import React__default, { forwardRef } from 'react';
import '../../node_modules/prop-types/index.js';
import classNames from '../../node_modules/classnames/index.js';
import { exports as propTypesExports } from '../../_virtual/index.js';

var CListGroup = forwardRef(function (_a, ref) {
    var _b;
    var children = _a.children, className = _a.className, _c = _a.component, Component = _c === void 0 ? 'ul' : _c, flush = _a.flush, layout = _a.layout;
    var _className = classNames('list-group', (_b = {
            'list-group-flush': flush
        },
        _b["list-group-".concat(layout)] = layout,
        _b), className);
    return (React__default.createElement(Component, { className: _className, ref: ref }, children));
});
CListGroup.propTypes = {
    children: propTypesExports.node,
    className: propTypesExports.string,
    component: propTypesExports.elementType,
    flush: propTypesExports.bool,
    layout: propTypesExports.oneOf([
        'horizontal',
        'horizontal-sm',
        'horizontal-md',
        'horizontal-lg',
        'horizontal-xl',
        'horizontal-xxl',
    ]),
};
CListGroup.displayName = 'CListGroup';

export { CListGroup };
//# sourceMappingURL=CListGroup.js.map
