import { __rest, __assign } from '../../node_modules/tslib/tslib.es6.js';
import React__default, { forwardRef } from 'react';
import '../../node_modules/prop-types/index.js';
import classNames from '../../node_modules/classnames/index.js';
import { colorPropType } from '../Types.js';
import { CLink } from '../link/CLink.js';
import { exports as propTypesExports } from '../../_virtual/index.js';

var CListGroupItem = forwardRef(function (_a, ref) {
    var _b;
    var children = _a.children, active = _a.active, className = _a.className, disabled = _a.disabled, color = _a.color, _c = _a.component, component = _c === void 0 ? 'li' : _c, rest = __rest(_a, ["children", "active", "className", "disabled", "color", "component"]);
    var _className = classNames('list-group-item', (_b = {},
        _b["list-group-item-".concat(color)] = color,
        _b['list-group-item-action'] = component === 'a' || component === 'button',
        _b.active = active,
        _b.disabled = disabled,
        _b), className);
    var Component = component === 'a' || component === 'button' ? CLink : component;
    rest = __assign(__assign(__assign(__assign({}, ((component === 'a' || component === 'button') && {
        active: active,
        disabled: disabled,
        component: component,
        ref: ref,
    })), (active && { 'aria-current': true })), (disabled && { 'aria-disabled': true })), rest);
    return (React__default.createElement(Component, __assign({ className: _className }, rest), children));
});
CListGroupItem.propTypes = {
    active: propTypesExports.bool,
    children: propTypesExports.node,
    className: propTypesExports.string,
    color: colorPropType,
    component: propTypesExports.elementType,
    disabled: propTypesExports.bool,
};
CListGroupItem.displayName = 'CListGroupItem';

export { CListGroupItem };
//# sourceMappingURL=CListGroupItem.js.map
