import { __rest, __assign } from '../../node_modules/tslib/tslib.es6.js';
import React__default, { forwardRef, useContext } from 'react';
import '../../node_modules/prop-types/index.js';
import { CModalContext } from './CModal.js';
import { CCloseButton } from '../close-button/CCloseButton.js';
import classNames from '../../node_modules/classnames/index.js';
import { exports as propTypesExports } from '../../_virtual/index.js';

var CModalHeader = forwardRef(function (_a, ref) {
    var children = _a.children, className = _a.className, _b = _a.closeButton, closeButton = _b === void 0 ? true : _b, rest = __rest(_a, ["children", "className", "closeButton"]);
    var setVisible = useContext(CModalContext).setVisible;
    var _className = classNames('modal-header', className);
    return (React__default.createElement("div", __assign({ className: _className }, rest, { ref: ref }),
        children,
        closeButton && React__default.createElement(CCloseButton, { onClick: function () { return setVisible(false); } })));
});
CModalHeader.propTypes = {
    children: propTypesExports.node,
    className: propTypesExports.string,
    closeButton: propTypesExports.bool,
};
CModalHeader.displayName = 'CModalHeader';

export { CModalHeader };
//# sourceMappingURL=CModalHeader.js.map
