import { __rest, __assign } from '../../node_modules/tslib/tslib.es6.js';
import React__default, { forwardRef, useRef, useContext, useEffect } from 'react';
import '../../node_modules/prop-types/index.js';
import classNames from '../../node_modules/classnames/index.js';
import { useForkedRef } from '../../utils/hooks/useForkedRef.js';
import { CNavContext } from '../sidebar/CSidebarNav.js';
import { CLink } from '../link/CLink.js';
import { exports as propTypesExports } from '../../_virtual/index.js';

var CNavLink = forwardRef(function (_a, ref) {
    var children = _a.children, className = _a.className, idx = _a.idx, rest = __rest(_a, ["children", "className", "idx"]);
    var navLinkRef = useRef(null);
    var forkedRef = useForkedRef(ref, navLinkRef);
    var setVisibleGroup = useContext(CNavContext).setVisibleGroup;
    var _className = classNames('nav-link', className);
    useEffect(function () {
        var _a;
        rest.active = (_a = navLinkRef.current) === null || _a === void 0 ? void 0 : _a.classList.contains('active');
        idx && rest.active && setVisibleGroup(idx);
    }, [rest.active, className]);
    return (React__default.createElement(CLink, __assign({ className: _className }, rest, { ref: forkedRef }), children));
});
CNavLink.propTypes = {
    children: propTypesExports.node,
    className: propTypesExports.string,
    idx: propTypesExports.string,
};
CNavLink.displayName = 'CNavLink';

export { CNavLink };
//# sourceMappingURL=CNavLink.js.map
