import { __rest, __assign } from '../../node_modules/tslib/tslib.es6.js';
import React__default, { forwardRef } from 'react';
import '../../node_modules/prop-types/index.js';
import classNames from '../../node_modules/classnames/index.js';
import { CLink } from '../link/CLink.js';
import { exports as propTypesExports } from '../../_virtual/index.js';

var CPaginationItem = forwardRef(function (_a, ref) {
    var children = _a.children, className = _a.className, component = _a.component, rest = __rest(_a, ["children", "className", "component"]);
    var _className = classNames('page-item', {
        active: rest.active,
        disabled: rest.disabled,
    }, className);
    var Component = component ? component : rest.active ? 'span' : 'a';
    return (React__default.createElement("li", __assign({ className: _className }, (rest.active && { 'aria-current': 'page' })), Component === 'a' ? (React__default.createElement(CLink, __assign({ className: "page-link", component: Component }, rest, { ref: ref }), children)) : (React__default.createElement(Component, { className: "page-link", ref: ref }, children))));
});
CPaginationItem.propTypes = {
    children: propTypesExports.node,
    className: propTypesExports.string,
    component: propTypesExports.elementType,
};
CPaginationItem.displayName = 'CPaginationItem';

export { CPaginationItem };
//# sourceMappingURL=CPaginationItem.js.map
