import { __rest, __assign } from '../../node_modules/tslib/tslib.es6.js';
import React__default, { forwardRef } from 'react';
import '../../node_modules/prop-types/index.js';
import classNames from '../../node_modules/classnames/index.js';
import { CCard } from '../card/CCard.js';
import { CCardBody } from '../card/CCardBody.js';
import { exports as propTypesExports } from '../../_virtual/index.js';

var CWidgetStatsE = forwardRef(function (_a, ref) {
    var chart = _a.chart, className = _a.className, title = _a.title, value = _a.value, rest = __rest(_a, ["chart", "className", "title", "value"]);
    var _className = classNames(className);
    return (React__default.createElement(CCard, __assign({ className: _className }, rest, { ref: ref }),
        React__default.createElement(CCardBody, { className: "text-center" },
            title && (React__default.createElement("div", { className: "text-medium-emphasis small text-uppercase fw-semibold" }, title)),
            value && React__default.createElement("div", { className: "fs-6 fw-semibold py-3" }, value),
            chart)));
});
CWidgetStatsE.propTypes = {
    children: propTypesExports.node,
    chart: propTypesExports.oneOfType([propTypesExports.string, propTypesExports.node]),
    className: propTypesExports.string,
    title: propTypesExports.oneOfType([propTypesExports.string, propTypesExports.node]),
    value: propTypesExports.oneOfType([propTypesExports.string, propTypesExports.node, propTypesExports.number]),
};
CWidgetStatsE.displayName = 'CWidgetStatsE';

export { CWidgetStatsE };
//# sourceMappingURL=CWidgetStatsE.js.map
